//
//  Header.m
//  我的下拉刷新
//
//  Created by ly on 16/9/30.
//  Copyright © 2016年 ZST. All rights reserved.
//

#import "Header.h"
@implementation Header

+ (instancetype)initWithDoingSomething :(doingSomething )doingSomething {
    Header * header = [[Header  alloc] initWithFrame:CGRectMake(0, -200, Screen_Weidth, 200)];
    header.doingSomething = doingSomething;

    return header ;
}

- (instancetype)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [[UIColor grayColor] colorWithAlphaComponent:0.2] ;
        self.textLabel = [[UILabel alloc]initWithFrame:CGRectMake(Screen_Weidth/2-100, 150, 200, 50)];
        self.textLabel.textAlignment = NSTextAlignmentCenter ;
        self.textLabel.textColor = [UIColor blackColor];
        self.textLabel.font = [UIFont  systemFontOfSize:12] ;
        [self addSubview: self.textLabel ];
        
        [self addSubview:self.indicator];

    }
    return self;
}

- (void)setScrollView:(UIScrollView *)scrollView {
    _scrollView = scrollView ;
    [_scrollView addSubview: self ] ;
    // 只考虑了contentOffset,没有考虑contentInset,
    // 适用于没有设置过contentInset的scrollView,基本上大家都不会动这个属性吧
    [_scrollView addObserver:self forKeyPath:@"contentOffset" options:NSKeyValueObservingOptionNew context:nil] ;
}

- (void)observeValueForKeyPath:(NSString *)keyPath ofObject:(id)object change:(NSDictionary<NSKeyValueChangeKey,id> *)change context:(void *)context {
    
    if ([keyPath isEqualToString:@"contentOffset"] == NO || self.isReload == YES) {
        return ;
    }
    NSLog(@"change  -- %@",change) ;
    CGPoint newPoint = [change[@"new"] CGPointValue] ;
    if (newPoint.y <= - 50) {
        if (self.autoDrag) {
            self.autoDrag = NO ;
            self.isReload = NO ;
            [self beginAnimation];
            return ;
        }
        if (self.scrollView.isDragging) {
            self.textLabel.text =  @"⇡ 松开即可刷新" ;
            return ;
        }
        if (self.isReload == NO) {
            [self beginAnimation] ;
        }
    }else if (newPoint.y > -50 && newPoint.y < 0){
        self.textLabel.text = @"⇣ 继续下拉刷新" ;
    }else {
        self.isReload = NO;
    }
    
}


- (void) beginAnimation {
    if (self.isReload == YES) {
        return ;
    }
    self.isReload = YES ;
    self.textLabel.text = @"正在加载中..." ;
    [_indicator startAnimating];
    [self.scrollView setContentOffset:CGPointMake(0, -50) animated:YES ];
    self.doingSomething();
}


- (void) endAnimation {
    self.isReload = NO ;
    self.textLabel.text = @"加载完成" ;
    [_indicator stopAnimating];
    [UIView animateWithDuration:0.2 animations:^{
        self.scrollView.contentOffset = CGPointZero ;
    }];
    
}


- (UIActivityIndicatorView *)indicator {
    /**
     UIActivityIndicatorViewStyleWhiteLarge,    // 大白
     UIActivityIndicatorViewStyleWhite,         // 小白
     UIActivityIndicatorViewStyleGray,          // 小灰灰
     */
    if (_indicator==nil) {
        _indicator = [[UIActivityIndicatorView alloc] initWithActivityIndicatorStyle:UIActivityIndicatorViewStyleWhite];
                _indicator.frame = CGRectMake(Screen_Weidth/2-80, 150, 50, 50);
        // 活动指示器, 是一个指示活动状态的视图, 需要手动开启活动状态后, 才能显示
        // 开始活动
//        [_indicator startAnimating];
        
        // 停止活动
        [_indicator stopAnimating];
        
        // 添加到视图
    }
    return _indicator;
    
}


@end
